<?php

namespace Drupal\module_builder_test_component_type;

use Drupal\module_builder\DrupalCodeBuilder;

/**
 * Library wrapper service for tests.
 *
 * This switches the environment and the Generate task.
 */
class TestDrupalCodeBuilder extends DrupalCodeBuilder {

  /**
   * Gets a task handler from the library.
   *
   * Same parameters as \DrupalCodeBuilder\Factory::getTask().
   *
   * @param string $task_name
   *   The task name.
   * @param mixed $task_options
   *   (optional) Options for the task.
   *
   * @return
   *   The task object.
   */
  public function getTask($task_name, $task_options = NULL) {
    if (!$this->loaded) {
      $this->loadLibrary();
    }

    return new TestGenerateTask();
  }

  /**
   * {@inheritdoc}
   */
  protected function doLoadLibrary() {
    $environment = new TestEnvironment();

    \DrupalCodeBuilder\Factory::setEnvironment($environment)
      ->setCoreVersionNumber(\Drupal::VERSION);
  }

}